import { Http,Util } from '@/utils';
import EntityService from '../entity-service';



/**
 * 角色权限关系服务对象基类
 *
 * @export
 * @class SYS_ROLE_PERMISSIONServiceBase
 * @extends {EntityServie}
 */
export default class SYS_ROLE_PERMISSIONServiceBase extends EntityService {

    /**
     * Creates an instance of  SYS_ROLE_PERMISSIONServiceBase.
     * 
     * @param {*} [opts={}]
     * @memberof  SYS_ROLE_PERMISSIONServiceBase
     */
    constructor(opts: any = {}) {
        super(opts);
    }

    /**
     * 初始化基础数据
     *
     * @memberof SYS_ROLE_PERMISSIONServiceBase
     */
    public initBasicData(){
        this.APPLYDEKEY ='sys_role_permission';
        this.APPDEKEY = 'rolepermissionid';
        this.APPDENAME = 'sys_role_permissions';
        this.APPDETEXT = 'rolepermission';
    }

// 实体接口

    /**
     * Select接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof SYS_ROLE_PERMISSIONServiceBase
     */
    public async Select(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.sys_role && context.sys_role_permission){
            return Http.getInstance().get(`/sys_roles/${context.sys_role}/sys_role_permissions/${context.sys_role_permission}/select`,isloading);
        }
        if(context.sys_permission && context.sys_role_permission){
            return Http.getInstance().get(`/sys_permissions/${context.sys_permission}/sys_role_permissions/${context.sys_role_permission}/select`,isloading);
        }
            return Http.getInstance().get(`/sys_role_permissions/${context.sys_role_permission}/select`,isloading);
    }

    /**
     * FetchDefault接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof SYS_ROLE_PERMISSIONServiceBase
     */
    public async FetchDefault(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.sys_role && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            return Http.getInstance().get(`/sys_roles/${context.sys_role}/sys_role_permissions/select`,tempData,isloading);
        }
        if(context.sys_permission && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            return Http.getInstance().get(`/sys_permissions/${context.sys_permission}/sys_role_permissions/select`,tempData,isloading);
        }
        let tempData:any = JSON.parse(JSON.stringify(data));
        return Http.getInstance().get(`/sys_role_permissions/select`,tempData,isloading);
    }
}